% Compute the connection matrices of the individual gcells.
%
% function ems = connection(self)
%
% Return an array of the element matrices so they may be assembled.
%
function ems = connection(self)
    gcells = get(self,'gcells');
    nfens = get(gcells,'nfens');
    % Prepare some data: connectivity and the element matrices
    conns = get(gcells, 'conn'); % connectivity
    nconns =size(conns,1);
    Ke = cell(nconns,1);
    eqnums = cell(nconns,1);
    nfens = size(conns,2);
    O =ones(nfens);
    conns =conns';
    for i=1:nconns
        eqnums{i} =conns(:,i);
        Ke{i} = O;
    end
    ems  = elematset(struct('mat',{Ke}, 'eqnums',{eqnums}));
end
