% Evaluate the Jacobian matrix.
%
% function J = Jacobian_matrix (self, Nder, x)
%
%   where
%      self=gcell whose basis functions derivatives are to be evaluated,
%      Nder=matrix of basis function derivatives wrt parametric 
%           coordinates (see bfundpar); size(Nder) = [nbfuns,dim]
%      x=array of spatial coordinates of the nodes, size(x) = [nbfuns,dim]
% 
%      nbfuns=number of nodes (== number of basis functions) per gcell
%           of the class class(self)
function J = Jacobian_matrix (self, Nder, x)
    J = x' * Nder;% Compute the Jacobian matrix
end
