% Set property in the specified object.
%
% function retval = set(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function retval = set(self,varargin)
    if (nargin == 1)
        retval={{{'label'}, {'user-interpreted label'}};...
            {{'conn'}, {'connectivity'}}};
        return;
    end
    prop_name=varargin{1};
    val=varargin{2};
    switch prop_name
        case 'label'
            if (length(val)==size(self.conn,1))
                self.label=val;
            elseif (length(val)==1)
                self.label=val+zeros(size(self.conn,1),1);
            else
                error(['Label of wrong length']);
            end
        case 'conn'
            if size(self.conn,2)~=size(val,2)
                error(['Connectivity of wrong length']);
            end
            self.conn=val;
        otherwise
            error(['Unknown property ''' prop_name '''!']);
    end
    retval=self; % return self
end
