% Evaluate the volume Jacobian.
%
% function Jac = Jacobian_volume(self, conn, N, J, x)
%
%   where
%      self=gcellset,
%      conn=connectivity of a single cell in which the Jacobian is to be evaluated
%      N=values of the basis functions, size(N) = [nbfuns,1]
%      J = Jacobian matrix
%      x=array of spatial coordinates of the nodes, size(x) = [nbfuns,dim]
%
function Jac = Jacobian_volume(self, conn, N, J, x)
    [sdim, ntan] = size(J);
    if     ntan==3
        Jac = det(J);% Compute the Jacobian
    else
        error('Got an incorrect size of tangents');
    end
end
