% get: Get property from the specified object and return the value. 
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where 
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string, 
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
if (nargin == 1)
    val = char(...
        'I - tensor of inertia, body frame',...
        'R - rotation matrix',...
        'Omega - angular velocity, body frame',...
        'omega - angular velocity, spatial frame');
    return;
else
    prop_name=varargin{1};
    switch prop_name
        case 'I'
            val=self.I;
        case 'R'
            val=self.R;
        case 'Omega'
            val=self.Omega;
        case 'omega'
            val=self.R*self.Omega;
        otherwise
            val = get(self.rotint, prop_name);
    end
end


