% Assemble a cell array of element matrices.
%
% function retobj = assemble (self, ems)
%
% Assemble a cell array of element matrices, that is object of type elemat,
% into a sparse matrix.
% -- This class does not support multiple assemble() calls. For instance, 
% it is not possible to do
%           A= assemble(A,ems1);
%           A= assemble(A,ems2);
% Rather, the above must be accomplished by concatenating the element 
% matrix objects and calling assemble() only once
%           A= assemble(A,cat(2,ems1,ems2));
% 
function retobj = assemble (self, ems)
    self.assemble_method (ems)
    retobj = self;
end