% Mesh 
[fens,gcells]=H8_block(h,l,2*pi,nh,nl,nc);
[fens,gcells] = H8_to_H27(fens,gcells);
xyz=get (fens,'xyz');
for i=1:count (fens)
    x=xyz(i,1); y=xyz(i,2); z=xyz(i,3);
    xyz(i,:)= [x+Rm-h/2, y-l/2, 0];
    xyz(i,:) = xyz(i,:)*[cos(psi*pi/180),sin(psi*pi/180),0;-sin(psi*pi/180),cos(psi*pi/180),0;0,0,1]*rotmat([0, z, 0]);
end
fens=set(fens,'xyz', xyz);
[fens,gcells] = merge_nodes(fens, gcells,  tolerance);
% Material
prop = property_linel_iso(struct('E',E,'nu',nu,'rho',rho));
% Note that for the axially symmetric 3-D model the properties are fully 3-D
mater = mater_defor_ss_linel_triax (struct('property',prop));
 
drawmesh({fens,gcells},'gcells','facecolor','red','shrink',1)
labels x y z

% Finite element block
feb = feblock_defor_ss (struct ('mater',mater, 'gcells',gcells,...
    'integration_rule',gauss_rule(3,3)));
% Geometry
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
limits =reshape([min(get(geom,'values'));max(get(geom,'values'))], 6, 1);
% Define the displacement field: note that there are 3 of freedom per node
u   = field(struct ('name',['u'], 'dim', 3, 'data',zeros(count(fens),3)));