% Mesh 
[fens,gcells]=Q4_block(rex-rin,pi/2,nR,nC,struct('axisymm',true));
bdry_gcells = mesh_bdry(gcells, struct('axisymm', true));
icl = gcell_select(fens, bdry_gcells, struct('box', [0,0,0,pi/2],'inflate',rin/100));
xy=get (fens,'xyz');
for i=1:count(fens)
    r=rin+xy(i,1); a=xy(i,2);
    xy(i,:)=[r*cos(a) r*sin(a)];
end
fens=set(fens,'xyz', xy);
% Material
prop = property_linel_iso(struct('E',E,'nu',nu,'rho',rho));
% Note that for the axially symmetric 3-D model the properties are fully 3-D
mater = mater_defor_ss_linel_triax (struct('property',prop));
 
% drawmesh({fens,gcells},'gcells','facecolor','red','shrink',0.85)
% labels x y z

% Finite element block
feb = feblock_defor_ss_3daxi (struct ('mater',mater, 'gcells',gcells,...
    'integration_rule',gauss_rule(2,2)));
% Geometry
geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
limits =reshape([min(get(geom,'values'));max(get(geom,'values'))], 4, 1);
% Define the displacement field: note that there are 3 of freedom per node
u   = field(struct ('name',['u'], 'dim', 3, 'data',zeros(count(fens),3)));