% Mesh 
[fens,gcells]=Q4_block(h,l,nh,nl,struct('axisymm',true));
xy=get (fens,'xyz');
for i=1:count(fens)
    xy(i,:)=xy(i,:)+ [Rm,0]-[h/2,l/2];
    xy(i,:) =xy(i,:)*[cos(psi*pi/180),sin(psi*pi/180);-sin(psi*pi/180),cos(psi*pi/180)];
end
fens=set(fens,'xyz', xy);
% Material
prop = property_linel_iso(struct('E',E,'nu',nu,'rho',rho));
% Note that for the axially symmetric 3-D model the properties are fully 3-D
mater = mater_defor_ss_linel_triax (struct('property',prop));
 
drawmesh({fens,gcells},'gcells','facecolor','red','shrink',1)
labels x y z

% Finite element block
feb = feblock_defor_ss_3daxi (struct ('mater',mater, 'gcells',gcells,...
    'integration_rule',gauss_rule(2,2)));
% Geometry
geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
limits =reshape([min(get(geom,'values'));max(get(geom,'values'))], 4, 1);
% Define the displacement field: note that there are 3 of freedom per node
u   = field(struct ('name',['u'], 'dim', 3, 'data',zeros(count(fens),3)));