function [h,se]=bradaigh_bending_45_compressible
    u=physical_units_struct;
    mu_T= 1.0*u.KILO*u.PA; % arbitrary
    mu_L= 1.7*mu_T; % given
    G12=mu_L; % given
    nu23=0.4; % arbitrary
    E2=2*(1+nu23)*mu_T; % relationship between the shear modulus and the Young's modulus in the second direction
    %    Now we use the (almost) incompressibility condition
    nu12=0.;
    E1=10000000*E2;  % and we enforce approximately the inextensibility of the fibers
    
    H=100*u.MM;% Arbitrary
    W=2.67*H;%  Given
    t=1*u.MM;% Arbitrary
    magn=100*u.PA;
    convse =  0.756858101210311;
    ang=45/360*2*pi; % 0 means fibers along the length of the beam
    
    graphics=~true;
    smult=0;
    stabfact=0.;
    
    %     Meshf=@T3_block;
    %     n_Multiplier=1;
    %     integration_rule = simplex_nq_rule(struct('dim',2,'order',1));
    %     surface_integration_rule=simplex_nq_rule(struct('dim',1,'order',1));
    %     febf =@feblock_defor_ss_nice;
    %     styl ='b*-';
    
    %     Meshf=@T3_blocku;
    %     n_Multiplier=1;
    %     integration_rule = simplex_nq_rule(struct('dim',2,'order',1));
    %     surface_integration_rule=simplex_nq_rule(struct('dim',1,'order',1));
    %     febf =@feblock_defor_ss_nice;
    %     styl ='b*-';
    
    %                 Meshf=@Q4_block;
    %                 n_Multiplier=2;
    %                 integration_rule = gauss_rule(2,2);
    %                 surface_integration_rule=gauss_rule(1,3);
    %                 febf =@feblock_defor_ss;
    %                 styl ='b*-';
    
    %     Meshf=@T3_block;
    %     n_Multiplier=1;
    %     integration_rule = tri_rule(1);
    %     surface_integration_rule=gauss_rule(2,1);
    %     febf =@feblock_defor_ss;
    %     styl ='b*-';
    
    %         Meshf=@Q9_block;
    %         n_Multiplier=1;
    %         integration_rule = gauss_rule(2,3);
    %         surface_integration_rule=gauss_rule(1,3);
    %         febf =@feblock_defor_ss;
    %         styl ='b*-';
    
            Meshf=@Q4_block;
            n_Multiplier=8;
            integration_rule = tensprod_nq_rule(struct('dim',2,'order',1));
            surface_integration_rule=tensprod_nq_rule(struct('dim',1,'order',1));
            febf =@feblock_defor_ss_nice;
            styl ='bs-';
    
            %             Meshf=@Q9_block;
            %             n_Multiplier=1;
            %             integration_rule = tensprod_nq_rule(struct('dim',2,'order',2));
            %             surface_integration_rule=tensprod_nq_rule(struct('dim',1,'order',2));
            %             febf =@feblock_defor_ss_nice;
            %             styl ='bd-';
    
            %             Meshf=@Q16_block;
            %             n_Multiplier=1;
            %             integration_rule = tensprod_nq_rule(struct('dim',2,'order',3));
            %             surface_integration_rule=tensprod_nq_rule(struct('dim',1,'order',3));
            %             febf =@feblock_defor_ss_nice;
            %             styl ='b*-';
    
    
    
    h=[];
    se=[];
    for n= n_Multiplier*[3, 6, 12, 24,  ]
        % for n= [6]
        [fens,gcells] = Meshf(W,H, n, n, t);
        htol=min(W/(2*n),H/(2*n));
        %     dxy=min(W,H)/n/2/100;
        %     sxy=smult*dxy;
        %     rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
        %     xys=get (fens,'xyz');
        %     for i=1:count(fens)
        %         xy=xys(i,:);
        %         if (xy(1)>dxy) & (xy(2)>dxy) & (xy(1)<W-dxy) & (xy(2)<H-dxy)
        %             xy=[xy(1)+(2*rand(1)-1)/2*sxy,xy(2)+(2*rand(1)-1)/2*sxy];
        %         end
        %         xys(i,:)=xy;
        %     end
        %     fens=set(fens,'xyz', xys);
        %         mesh{1}=fens;
        %         mesh{2}=gcells;
        %         drawmesh(mesh); view (2); pause
        % Material
        Prop =property_linel_transv_iso(struct('E1',E1,'E2',E2,'nu12',nu12,'nu23',nu23,'G12',G12));
        mater = mater_defor_ss_linel_biax (struct ('property', Prop,'reduction', ['stress']));
        %         D=tangent_moduli (mater, [])
        %         [V,N]=eig(D)
        % Finite element block
        feb = febf(struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',integration_rule,...
            'stabfact',stabfact,'Rm',[cos(ang) sin(ang); -sin(ang) cos(ang)]));
        bdry_gcells = mesh_bdry(gcells, struct('other_dimension', 1));
        icl = gcell_select(fens, bdry_gcells, struct('box', [0 W H H],'inflate',htol/1000));
        efeb = feblock_defor_ss (struct ('mater',mater, 'gcells',subset(bdry_gcells,icl),...
            'integration_rule',surface_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero outfunction five
        % Apply EBC's
        % Clamped at  X =0
        ebc_fenids=fenode_select (fens,struct('box',[0, 0, 0, H],'inflate',htol/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        % Load
        F = start (sysvec, get(u, 'neqns'));
        fi=force_intensity(struct('magn',[0;+magn]));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        % Solve
        u = scatter_sysvec(u, K\F);
        h=[h W/n];
        se =[se gather_sysvec(u)'*get(F,'vec')/2];
        disp (['n=' num2str(n) ' Normalized  strain energy =' num2str(se(end)/convse)])
        
        % Plot
        if graphics
            gv=graphic_viewer;
            gv=reset (gv,struct ('limits',[-0.13*W, 1.13*W,-0.05*H, 1.95*H]));
            set(gca, 'Position',[0.18 0.1 0.78 0.8]);
            scale=10;
            cmap = jet;
            fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
            nvals=get(fld,'values');%min(nvals),max(nvals)
            % nvalsrange=[-0.0001 0.0001];%[min(nvals),max(nvals)]
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feb,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
            colormap(cmap);
            cbh=colorbar;
            set(cbh,...
                'Position',[0.04 0.15 0.05 0.7],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            set(get(cbh,'XLabel'),'String','Vol. strain');
            view (2)
        end
    end
    if ~graphics
        loglog(h,abs(convse-se)/convse,styl,'lineWIDTH', 3); hold on;
    end
end
% The following data comes from nice Q 16, with up to 96 elements per side
% h =[ 0.089000000000000   0.044500000000000   0.022250000000000   0.011125000000000   0.005562500000000   0.002781250000000
% ];
%
% se =[   0.120263309281060   0.364862294384275   0.568478366891875   0.672554902998172   0.720194692129402   0.740913207138184
%     ];
% [xestim, beta, c, residual] = richextrapol(se(end-2:end),h(end-2:end));;
