disp('Distortion test ');

% Parameters:
E=1500;
nu=0.0;
scale=5;
F = 10;
htol= 1/100;
graphics =  true;

Meshf=@T3_block;
integration_rule = simplex_nq_rule(2);
febf =@feblock_defor_ss_nice;
Style ='b*-';
%     Meshf=@Q4_block;
%     integration_rule = gauss_rule(2, 2);
%     febf =@feblock_defor_ss;
%     Style ='gs-';
    %     Meshf=@Q4_block;
    %     integration_rule = tensprod_nq_rule(2);
    %     febf =@feblock_defor_ss_nice;
    %     Style ='ro-';
   

% Mesh
[fens,gcells] = Meshf(10, 2, 2, 2, 1.0);
de=1;
for e=0:de:4
    propm = property_linel_iso(struct('E',E,'nu', nu));
    mater = mater_defor_ss_linel_biax (struct ('property',propm,'reduction','stress'));
    feb = febf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',integration_rule));
    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
    % Define the displacement field
    u   = clone(geom,'u');
    u   = u*0; % zero out
    % Apply EBC's
    nl=fenode_select (fens,struct ('box',[0 0 0 2],'inflate',htol));
    u   = set_ebc(u, nl, nl*0+1, nl*0+1, nl*0);
    u   = apply_ebc (u);
    nl=fenode_select (fens,struct ('box',[0 0 0 0],'inflate',htol));
    u   = set_ebc(u, nl, nl*0+1, nl*0+2, nl*0);
    u   = apply_ebc (u);
    % Number equations
    u   = numbereqns (u);
    % Assemble the stiffness matrix
    S = start (sparse_sysmat, get(u, 'neqns'));
    S = assemble (S, stiffness(feb, geom, u));
    % Load
    nl=fenode_select (fens,struct ('box',[10 10 0 0],'inflate',htol));
    L = start (sysvec, get(u, 'neqns'));
    L = assemble (L, loads(nodal_load(struct('id',nl,'dir',1,'magn',-F)), u));
    nl=fenode_select (fens,struct ('box',[10 10 2 2],'inflate',htol));
    L = assemble (L, loads(nodal_load(struct('id',nl,'dir',1,'magn', +F)), u));
    % Solve
    u = scatter_sysvec(u, get(S,'mat')\get(L,'vec'));
    nl=fenode_select (fens,struct ('box',[10 10 2 2],'inflate',htol));
    uA = gather (u,nl,'values');
    el=1;x=10*el;y=1*el;
    uAex =3*F/2/E*((x/el)^2+nu*((y/el)^2-1));
    nuA=(-uA(2))/uAex*100;
    disp (['e=' num2str(e) ', Normalized displacement under the load: ' num2str(nuA) '%'])

    % Plot
    if graphics
        gv=graphic_viewer;
        % for i=1:length(fens)
        %     draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
        % end
        gv=reset (clear (gv),struct('limits',[0 1.05*10 -1.5*2 1.5*2]));
        draw(feb,gv, struct ('x', geom, 'u',scale*u, 'facecolor','none'));
        draw(feb,gv, struct ('x', geom, 'u',0*u, 'facecolor','none'));
        view (2)
    else
         plot(e,nuA, Style); hold on
    end
    xys=get(fens,'xyz');
    xy=xys(2,:);
    xys(2,:) =xy+[de,0];
    xy=xys(8,:);
    xys(8,:)=xy-[de,0];
    fens=set(fens,'xyz',xys);
    
end