function platension
    WIDTH=44;
    LENGTH=44;
    uxbar=0.1*LENGTH;
    graphics=  true;
    doeig=~true;
    aspect=1;
    stabfact=0.;
    
    lambda = 0.75;
    G= 0.375;
    
    lambda = 0.75e7;
    G= 0.375;
    

    nu =1/2*lambda/(G+lambda)
    E=G*(3*lambda+2*G)/(G+lambda);

    %
    Meshf=@T3_block; ne=[4,8,16,32];
    Convertf=[];
    integration_rule =simplex_nq_rule(struct('dim',2,'order',1));
    Edge_integration_rule =gauss_rule(1, 1);
    febf =@feblock_defor_ss_nice;
    Style ='m^-'; Label='NICE-T3';
%     %
%     Meshf=@Q4_block; ne=[2,4,8,16];
%     Convertf=[];
%     integration_rule =tensprod_nq_rule(struct('dim',2,'order',1));
%     Edge_integration_rule =tensprod_nq_rule(struct('dim',1,'order',1));
%     febf =@feblock_defor_ss_nice;
%     Style ='md-'; Label='NICE-Q4';



    %     Meshf=@Q4_block; ne=[1,2,4,8,16];
    %     Convertf=@Q4_to_Q9;
    %     integration_rule =tensprod_nq_rule(struct('dim',2,'order',2));
    %     Edge_integration_rule =tensprod_nq_rule(struct('dim',1,'order',2));
    %     febf =@feblock_defor_ss_nice;
    %     Style ='ms-'; Label='NICE-Q9';
    %


    %     Meshf=@Q4_block; ne=[1,2,4,8,16];
    %     Convertf=@Q4_to_Q9;
    %     integration_rule =gauss_rule(2,3);
    %     Edge_integration_rule =gauss_rule(1,3);
    %     febf =@feblock_defor_ss;
    %     Style ='bx-'; Label='Q9';
    


  

%     Meshf=@t3block2d; ne=[2,4,8,16];
%     Convertf=@T3_to_T6;
%     integration_rule =tri_rule(6);
%     febf =@feblock_defor_ss;
%     Style ='kx-'; Label='T6';

    % Meshf=@ablockT6; ne=[2,4,8,16];
    % Convertf=[];
    % integration_rule =tri_rule(3);
    % febf =@feblock_defor_ss;
    % Style ='kx-'; Label='T6';
% 
%         Meshf=@block2d; ne=[4,8,16,32];
%     Convertf=[];
%         integration_rule = gauss_rule(2, [1 2]);
%         febf =@feblock_defor_ss_sri;
%         Style ='gs-'; Label='Q4-SRI';
% 
%         Meshf=@block2d; ne=[4,8,16,32];
%     Convertf=[];
%         integration_rule = gauss_rule(2, 2);
%         febf =@feblock_defor_ss;
%         Style ='gs-'; Label='Q4';



    % Mesh
    h=[];
    utip=[];
    magn=1;
    %     for n=[4,8,16,32]
    for n=ne
        % for n=[2,4,8,16,32,64,128]
        options =struct('other_dimension', 1.0);
        [fens,gcells] = Meshf(LENGTH, WIDTH,n, aspect*n, options);
        if (~isempty( Convertf ))
            [fens,gcells] = Convertf(fens,gcells, options);
        end
%                     mesh{1}=fens;
%                     mesh{2}=gcells;
%                     drawmesh(mesh,'facecolor','y'); view(2); pause (1)
        propm = property_linel_iso(struct('E',E,'nu', nu));
        mater = mater_defor_ss_linel_biax (struct ('property',propm,'reduction','strain'));
        feb = febf(struct ('mater',mater, 'gcells',gcells, ...
            'integration_rule',integration_rule,...
            'stabfact',stabfact));

        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
        % Define the displacement field
        u   = clone(geom,'u');
        u   = u*0; % zero outfunction five
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[0,0,0,WIDTH],'inflate',WIDTH/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        ebc_fenids=fenode_select (fens,struct('box',[LENGTH,LENGTH,0,WIDTH],'inflate',WIDTH/10000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=ebc_fenids*0+1;
        ebc_val=ebc_fenids*0+uxbar;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u = apply_ebc (u);
        % Number equations
        u   = numbereqns (u);
        % Assemble the system matrix
        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, stiffness(feb, geom, u));
        % Load
        F = start (sysvec, get(u, 'neqns'));
        F = assemble (F, nz_ebc_loads(feb, geom, u));
        % Solve
        u = scatter_sysvec(u, K\F);
%         nl=fenode_select (fens,struct ('box',[48,48,52,52],'inflate',48/10000));
%         theutip=gather(u,nl,'values');
%         disp (['displacement =' num2str(theutip(2), 15)])
%         h=[h 44/n];
%         utip =[utip theutip(2)];

        % Plot
        if graphics
            gv=graphic_viewer;
            gv=reset (gv,struct ([]));
            scale=1;
            cmap = gray;
            cmap=jet;
%             fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
            fld = field_from_integration_points(feb, geom, u, [], 'Cauchy', 1);
%             fld = field_from_integration_points(feb, geom, u, [], 'pressure', 1);
            nvals=get(fld,'values');%min(nvals),max(nvals)
            %             nvalsrange=[-0.05, -0.02];%[min(nvals),max(nvals)]
            nvalsrange=[min(nvals),max(nvals)];
            dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
            draw(feb,gv, struct ('x', geom, 'u', scale*u,'colorfield',colorfield,...
                'edgecolor','white','shrink',1.0));
            xlabel('X','FontName','Times')
            ylabel('Y','FontName','Times')
            set(gca,'FontSize',14);
            set(gca,'FontName','Times')
            % geom3d=combine (geom, 0*fld);
            % u3d=combine (u, 100000000*fld);
            % draw(feb,gv, struct ('x', geom3d, 'u', +scale*u3d,'colorfield',colorfield, 'shrink',1.0));
            colormap(cmap);
            cbh=colorbar;
            set(cbh,'FontSize',14);
            set(cbh,'FontName','Times')
            set(cbh,...
                'Position',[0.825 0.247 0.035 0.51],...
                'YLim',[0,1],...
                'YTick',[0,1],...
                'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
            %             set(get(cbh,'XLabel'),'String','Volumetric strain');
            view (2)
            
        end
    end
    
end
