 function AVE188_3D
 figure;; hold on
% 0.20'' #fens=381, #gcells=1247
% 0.10'' #fens=2119, #gcells=9304
% 0.05'' #fens=15382, #gcells=79858
h= [0.2, 0.1, 0.05];

nn =[2299, 14587,  114692];
nnNICE =[381, 2119,15382];
ne = [1247,9304,79858];

% Autodesk simulation mechanical
% 0.20'' mesh size:  max stress xx = 3502.8 PSI (3844.47  not smoothed)
% 0.10'' mesh size:  max stress xx = 3658.35 PSI (3904.4  not smoothed)
% 0.05'' mesh size:  max stress xx = 3734.67 PSI (3770.54  not smoothed)
%
sASMsmooth = [3502.8,3658.35,3734.67]/3545*100;
% plot(h,sASMsmooth,'o-')
plot(ne*4,sASMsmooth,'o-')

sASM = [3844.47,3904.4,3770.54]/3545*100;
% plot(h,sASM,'x-')
plot(ne*4,sASM,'x-')
%
% NICE
% Maximum sigma_x=3154.0544 PSI
%  i.e. 88.9719% of the Reference value
% Maximum sigma_x=3462.6218 PSI
%  i.e. 97.6762% of the Reference value
% Maximum sigma_x=3544.2383 PSI
%  i.e. 99.9785% of the Reference value
sNICE=[88.9719,97.6762,99.9785];
% plot(h,sNICE,'^-')
plot(nnNICE,sNICE,'^-')
% 10 node tetrahedra and with SPR stress recovery
% #fens=2299, #gcells=1247
% Maximum sigma_x=3605.9552 PSI
%  i.e. 101.7195% of the Reference value
% #fens=14587, #gcells=9304
% Maximum sigma_x=3630.9691 PSI
%  i.e. 102.4251% of the Reference value
% #fens=114692, #gcells=79858
% Maximum sigma_x=3685.1047 PSI
%  i.e. 103.9522% of the Reference value
sT10SPR=[101.7195,102.4251,103.9522];
% plot(h,sT10SPR,'d-')
plot(ne*4,sT10SPR,'d-')

return;

disp('AVE 188 benchmark, 3-D meshes');
pu=physical_units_struct;
% Parameters:
E = 29000000*pu.PSI;
nu = 0.3;
p = 1000*pu.PSI;%
A=4*pu.IN; B= 2*pu.IN;
C=1*pu.IN; 
tolerance =0.00001*pu.IN;
sigma_xmaximum= 3545*pu.PSI;% Maximum tensile stress

% % NICE tetrahedron
% Meshf =@T4_block;
% Convertf=@T10_to_T4;
% febf =@feblock_defor_ss_nice;
% Volume_integration_rule= simplex_nq_rule (3);
% Edge_integration_rule=simplex_nq_rule (2);
% Style='r*-';
 
% T10 tetrahedron
Meshf =@T10_block;
Convertf=[];
febf =@feblock_defor_ss;
Volume_integration_rule=tet_rule (4);
Edge_integration_rule=tri_rule(3);
Style='gd-';
 
[fens,gcells]=mesh_import('ave188mesh2.inp',pu.IN);
if (~isempty( Convertf ))
  [fens,gcells] = Convertf(fens,gcells);
end
disp(['#fens=' num2str(count(fens)) ', ' '#gcells=' num2str(count(gcells))])
bdry_gcells = mesh_bdry(gcells, []);
% drawmesh( {fens,gcells},'gcells')
Tractioncl = gcell_select(fens, bdry_gcells, struct('box', [A,A,-Inf,Inf,-Inf,Inf],'inflate',A/10000));
SymmetryXZcl = gcell_select(fens, bdry_gcells, struct('box', [-Inf,Inf,0,0,-Inf,Inf],'inflate',A/10000));
SymmetryXYcl = gcell_select(fens, bdry_gcells, struct('box', [-Inf,Inf,-Inf,Inf,0,0],'inflate',A/10000));
Clampedcl = gcell_select(fens, bdry_gcells, struct('box', [0,0,-Inf,Inf,-Inf,Inf],'inflate',A/10000));
% view (2)
% return
prop = property_linel_iso (struct('E',E,'nu',nu));
mater = mater_defor_ss_linel_triax (struct('property',prop));
% Finite element block
feb = febf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',Volume_integration_rule));
efeb = febf (struct ('mater',mater, 'gcells',subset(bdry_gcells,Tractioncl),...
    'integration_rule',Edge_integration_rule));
% Geometry
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
% Define the displacement field
u   = clone(geom,'u');
u   = u*0; % zero out
% Apply EBC's
% Clamped
ebc_fenids=connected_nodes(subset(bdry_gcells,Clampedcl));
u   = set_ebc(u, ebc_fenids, true, [], 0);
% plane of symmetry
ebc_fenids=connected_nodes(subset(bdry_gcells,SymmetryXYcl));
ebc_prescribed=ones(1,length (ebc_fenids));
ebc_comp=ebc_prescribed*0+3;
ebc_val=ebc_fenids*0;
u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
ebc_fenids=connected_nodes(subset(bdry_gcells,SymmetryXZcl));
ebc_prescribed=ones(1,length (ebc_fenids));
ebc_comp=ebc_prescribed*0+2;
ebc_val=ebc_fenids*0;
u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
% Apply
u   = apply_ebc (u);
% Number equations
u   = numbereqns (u);
% tic
% Assemble the system matrix
K = start (sparse_sysmat, get(u, 'neqns'));
K = assemble (K, stiffness(feb, geom, u));
% Load
fi=force_intensity(struct('magn',[p,0,0]'));
F = start (sysvec, get(u, 'neqns'));
F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
% Solve
u = scatter_sysvec(u, K\F);
% get(u,'values')
% toc, tic
% Plot
gv=graphic_viewer;
gv=reset (gv,[]);
scale=1000;
cmap = jet;
fld = field_from_integration_points_spr(feb, geom, u, [], 'Cauchy',1);
max_sigma_xx_approx=max(get (fld, 'values'));
disp( ['Maximum sigma_x=' num2str(max_sigma_xx_approx/(pu.PSI)) ' PSI'])
disp( [' i.e. ' num2str(max_sigma_xx_approx/sigma_xmaximum*100) '% of the Reference value'])
nvals=get(fld,'values')/(pu.PSI);%min(nvals),max(nvals)
nvalsrange=[min(nvals),max(nvals)];
dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
draw(bdry_gcells,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
draw(bdry_gcells,gv, struct ('x', geom, 'u', 0*u,'facecolor','none', 'shrink',1.0));
% draw(efeb,gv, struct ('x', geom, 'u', 0*u,'facecolor','red', 'shrink',1.0));
colormap(cmap);
draw_colorbar(gv,struct('position',[0.815 0.15 0.05 0.7],'minmax',nvalsrange,'label','\sigma_y'));
set_graphics_defaults
% assignin('caller','faesor_test_passed',((norm([93.029698724563474]-gather(fld, corner,'values')))<1e-9))