%%  Define some auxiliary variables
% clear all classes;
E=1000;
nu=0.4999999;
nu=0.4999;
% nu=0.25;
W=2.5;
H=5;
L= 50;
htol=min([L,H,W])/1000;
uzex =-12.6;
magn = 0.2*uzex/4;
Force =magn*W*H*2;
% Force*L^3/(3*E*W*H^3*2/12)
graphics = ~true;

n_per_length=4;
eix=1;
clear eltyd
% NICE tetrahedron
eltyd(eix).legend ='NICE-T4-phys';
eltyd(eix).mf =@T4_block;
eltyd(eix).ns=(1:6);
eltyd(eix).blf =@feblock_defor_ss_nice_iso;
eltyd(eix).integration_rule=simplex_nq_rule (3);
eltyd(eix).surface_integration_rule=tri_rule(1);
eltyd(eix).styl='cp-';
eix=eix+1;
% % NICE tetrahedron
% eltyd(eix).legend ='NICE-T4';
% eltyd(eix).mf =@T4_block;
% eltyd(eix).ns=(1:6);
% eltyd(eix).blf =@feblock_defor_ss_nice;
% eltyd(eix).integration_rule=simplex_nq_rule (3);
% eltyd(eix).surface_integration_rule=tri_rule(1);
% eltyd(eix).styl='c^-';
% eix=eix+1;


results={};
Irresult=0;
stabfacts= [0,0.01, 0.05, 0.1, 0.5];

for stabfact=stabfacts;
    for eix = 1:length(eltyd)
        ns=[];
        uzs=[];
        for     n=eltyd(eix).ns;
            mult =n_per_length;
            %% Create the mesh and initialize the geometry
            [fens,gcells]= feval (eltyd(eix).mf, W, L, H,n,mult*n,2*n);
            prop = property_linel_iso (struct('E',E,'nu',nu));
            mater = mater_defor_ss_linel_triax (struct('property',prop));
            feb = feval (eltyd(eix).blf, struct ('mater',mater, 'gcells',gcells,...
                'integration_rule',eltyd(eix).integration_rule,...
                'stabfact',stabfact));
            geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
            u   = 0*geom;
            ebc_fenids=fenode_select(fens,struct('box',[0 W 0 0 0 H]));
            ebc_prescribed=ones(length(ebc_fenids),1);
            ebc_comp=[];
            ebc_val=zeros(length(ebc_fenids),1);
            u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
            ebc_fenids=fenode_select(fens,struct('box',[W W 0 L 0 H]));
            ebc_prescribed=ones(length(ebc_fenids),1);
            ebc_comp=ebc_fenids*0+1;
            ebc_val=zeros(length(ebc_fenids),1);
            u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
            u   = apply_ebc (u);
            u   = numbereqns (u);
            disp (['n=' num2str(n) ', number of equations =' num2str(get(u,'neqns'))]);
            K = start (sparse_sysmat, get(u, 'neqns'));
            K = assemble (K, stiffness(feb, geom, u));
            fi= force_intensity(struct ('magn',[0;0; magn]));
            bdry_gcells = mesh_bdry(gcells, []);
            bcl = gcell_select(fens, bdry_gcells, ...
                struct ('box',[0 W L L 0 H],'inflate',htol));
            lfeb = feblock_defor_ss(struct ('mater',mater, 'gcells',subset(bdry_gcells,bcl),...
                'integration_rule',eltyd(eix).surface_integration_rule));
            F = start (sysvec, get(u, 'neqns'));
            F = assemble (F, distrib_loads(lfeb, geom, u, fi,2));
            x=K\F;
            u = scatter_sysvec(u, x);
            ebc_fenids=fenode_select(fens,struct('box',[0 W L L 0 H]));
            uv=gather (u,ebc_fenids,'values','noreshape');
            uz=sum(uv(:, 3))/length(ebc_fenids);
            disp (['   Free end displacement =' num2str(uz)]);
            ns=[ns get(u,'neqns')];
            uzs =[uzs uz];
        end
    end
    result.legend=eltyd(eix).legend;
    result.styl=eltyd(eix).styl;
    result.stabfact=stabfact;
    result.ns=ns;
    result.uzs=uzs;
    Irresult=Irresult+1; results{Irresult}=result;
end

figure;
legends={};
for eix = 1:length(results)
    ns=    results{eix}.ns; uzs=results{eix}.uzs;
    legends{end+1}= [results{eix}.legend ', stabfact=' num2str(results{eix}.stabfact)];
    plot(ns,uzs/uzex,results{eix}.styl,'linewidth',3); hold on
end
legend(legends); grid on
labels( 'Number of equations', 'Normalized deflection');
set_graphics_defaults; set_label_defaults; title( ['\nu='  num2str(nu)]);
figure (gcf);


figure;
legends={};
for eix = 1:length(results)
    ns=    results{eix}.ns; uzs=results{eix}.uzs;
    legends{end+1}= [results{eix}.legend ', stabfact=' num2str(results{eix}.stabfact)];
    loglog(ns(2:end),abs(diff(uzs)),results{eix}.styl,'linewidth',3); hold on
end
legend(legends); grid on
labels( 'Number of equations', 'Approximate error of the deflection');
set_graphics_defaults; set_label_defaults; title( ['\nu='  num2str(nu)]);
figure (gcf);
