function [xyz,conn]=make_spherical_surface(Radius,nsubdivisions)
    if (~ exist ('Radius') )
        Radius=300;
    end
    if (~ exist ('nsubdivisions') )
        nsubdivisions=1;
    end
    tol=Radius/nsubdivisions/2/1000;
    [fens,gcells]=Q4_sphere(Radius,nsubdivisions,1);
    [fens1,gcells1] = mirror_mesh(fens, gcells, [-1,0,0], [0,0,0], @(c)c([1, 4, 3, 2]));
    [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
    gcells=cat(gcells1,gcells2);
    [fens1,gcells1] = mirror_mesh(fens, gcells, [0,-1,0], [0,0,0], @(c)c([1, 4, 3, 2]));
    [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
    gcells=cat(gcells1,gcells2);
    [fens1,gcells1] = mirror_mesh(fens, gcells, [0,0,-1], [0,0,0], @(c)c([1, 4, 3, 2]));
    [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
    gcells=cat(gcells1,gcells2);
    drawmesh({fens,gcells},'gcells','facecolor','red')
    xyz=get(fens, 'xyz' );
    conn=get(gcells,'conn' );
end