disp(' ');
disp('Holder, Leimkuhler, Reich (1999): Coulombic potential + soft wall');
cd(FAESOR_work_path);
[fens,gcells] = bigone;
feb = feblock(struct('gcells',gcells));
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
u = 0*geom;
graphics= ~true;
nRs=[];nmbfs=[];nmsps=[];
nmarkers=10; nadv=1; histoff=0;
if ~exist('cr','var'),cr=2;end
% clf;
% dts=[1/4 1/8 1/16];
% dts=[0.25];
marker_type='oxd*sdv^<>ph';
marker_type=[marker_type marker_type];
marker_type=[marker_type marker_type];
marker_type=[marker_type marker_type];
colors='rbgcykm'; colors=[colors colors]; colors=[colors colors]; colors=[colors colors]; colors=[colors colors];
colors=[colors colors]; colors=[colors colors]; colors=[colors colors]; colors=[colors colors];
graphics=0;
dts=[0.5];
tend=40000*dts;
setnum=0;
nrows=4;
iplot=1;
for plotwhat={'normhamilt'}
    for rin={'dyneq_imid' 'dyneq_trap' 'dyneq_imidm'  'dyneq_trapm'}
%     for rin={'dyneq_imid' 'akw_mid' 'bb_rkmk_trap'  'simo_wong_algo_c1'}
       ri=eval(['rotint_' rin{1}]);
            nRs=[];
        nmbfs=[];
        nmsps=[];
        for dt=dts;
            % Data, Initial conditions
            torque = inline('((-((1.1+R(3,3))^(-2))+10*0.001*((1.1+R(3,3))^(-11))))*[-R(2,3);R(1,3);0]','t', 'R');
            %             torque = @holere_torque;
            % Data, Initial conditions
            %I=diag([0.9218 0.7382 0.1762]);
            I=diag([2 3 4.5]);
            R = rotmat([0 0 0]);   
            exact_spm=[2;2;2];
            omega=I\exact_spm;
            Omega=R'*omega;
            converged_R_at_200 = [
                -9.635898742219888e-002   -9.935689205509644e-001   -5.946213634036374e-002
                3.477452484944876e-001   -8.958048117388300e-002    9.332998336773466e-001
                -9.326243550821927e-001    6.925415155676283e-002    3.541407556321036e-001
            ];
            converged_Omega_at_200 = [
                -7.332937064807837e-001
                -7.372956499395080e-001
                4.928404438064659e-001
            ];
            
            line='-';
            % Choose integrator
            ri = set(ri, 'I', I);
            ri = set(ri, 'R', R);
            ri = set(ri, 'omega', omega);
            
            limits=[-5 5 -5 5 -5 5];
            nsteps=round(tend/dt);
            reportat=nsteps/nadv/5;
            if (histoff)
                nsnapshots=100;
            else
                nsnapshots=nsteps+1;
            end
            omegas=zeros(3,nsnapshots);
            momenta=zeros(3,nsnapshots);
            kinenergy=zeros(1,nsnapshots);
            potenergy=zeros(1,nsnapshots);
            Omegas=zeros(3,nsnapshots);
            vectup=zeros(3,nsnapshots);
            incrrotvect=zeros(3,nsnapshots);
            rotvect=zeros(3,nsnapshots);
            incrrotvectmag=zeros(1,nsnapshots);
            proj_on_gravity=zeros(1,nsnapshots);
            proj_on_topaxis=zeros(1,nsnapshots);
            if graphics
                gv=graphic_viewer;
                gv=reset (gv,struct('limits',limits));
                draw(feb, gv,  struct ('x',geom,'u', u, 'facecolor','red'));
                headlight(gv);
            end
            tic;
            ri = set(ri, 't', 0);
            % store history for t=0
            snapshot=1;
            omega=get(ri, 'omega');
            R1=R;
            R=get(ri, 'R');
            V=rotmat2rotvec((R1')*R);
            incrrotvect(:,snapshot)=V;
            incrrotvectmag(:,snapshot)=norm(V)*180/pi;
            rotvect(:,snapshot)=rotmat2rotvec(R);
            omegas(:,snapshot)=omega;
            Omegas(:,snapshot)=R'*omega;
            L=R*I*R'*omega;
            momenta(:,snapshot)=L;
            kinenergy(snapshot)= 1/2*omega'*L;
            potenergy(snapshot)= (1.1+R(3,3))^(-1)-0.001*(1.1+R(3,3))^(-10);
            vectup(:,snapshot)=R(:,3);
            proj_on_gravity(snapshot)=L'*[0;0;1];
            proj_on_topaxis(snapshot)=L'*vectup(:,snapshot);
            for i=1:ceil(nsteps/nadv)
                % advance by one step
                ri = advance(ri, torque,dt,nadv);
                % save history
                if (histoff)
                    snapshot=2;
                else
                    snapshot=snapshot+1;
                end
                omega=get(ri, 'omega');
                R1=R;
                R=get(ri, 'R');
                V=rotmat2rotvec((R1')*R);
                incrrotvect(:,snapshot)=V;
                incrrotvectmag(:,snapshot)=norm(V)*180/pi;
                rotvect(:,snapshot)=rotmat2rotvec(R);
                omegas(:,snapshot)=omega;
                Omegas(:,snapshot)=R'*omega;
                L=R*I*R'*omega;
                momenta(:,snapshot)=L;
                kinenergy(snapshot)= 1/2*omega'*L;
                potenergy(snapshot)= +(1.1+R(3,3))^(-1)-0.001*(1.1+R(3,3))^(-10);
                vectup(:,snapshot)=R(:,3);
                proj_on_gravity(snapshot)=L'*[0;0;1];
                proj_on_topaxis(snapshot)=L'*vectup(:,snapshot);
                % graphics
                if graphics
                    currgeom=rotate(geom, R);
                    u=currgeom-geom;
                    gv=reset (gv,struct('limits',limits));
                    draw(feb, gv,  struct ('x',geom,'u', u, 'facecolor','red'));
                    headlight(gv); view(3)
                    pause(0.005); % next eigenvector
                end
                if (round(i/(reportat))*reportat == i)
                    disp([num2str(nadv*i) ' steps of ' num2str(nsteps) ' (' num2str(toc) ' sec)']);
                end
            end
            disp(['Reached time ' num2str(get(ri,'t'))]);
            toc
            
            if (graphics)
                plotwhat={'nothing'};
            end
            hold on
            npts=size(momenta,2);
            setnum=setnum+1;
                  subplot(nrows,1,iplot); 
            set(gca,'LineWidth',2);
            set(gca,'FontSize',16);
            set(gca,'TickLength',[0.025 0.06]);  % default values are: 0.0100 0.0250
            set(gca,'XGrid','on');
            set(gca,'YGrid','on');
            xlabel('Time');
            plotwhat1=plotwhat{1};
            if (~strcmp(class(plotwhat{1}),'char'))
                plotwhat1=num2str(plotwhat{1});
            end
            switch plotwhat1
                case {'0' 'kin'}
                    ylabel('Kinetic energy');
                    filename=[mfilename(1) '-kin-' num2str(dt)];
                    subplot(nrows,1,iplot); 
            plot(dt*(0:npts-1), kinenergy(1:npts), [colors(4) line], 'LineWidth', 1.5);    hold on            
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                   subplot(nrows,1,iplot); 
             plot(dt*(markers-1), kinenergy(markers), [colors(4) marker_type(setnum)], 'LineWidth', 1.5);                
                case '1'
                    ylabel('Normalized Kinetic energy');
                    filename=[mfilename '-normkin-' num2str(dt)];
                    plot(dt*(0:npts-1), (kinenergy(1:npts)-exactkinenergy)/exactkinenergy, [colors(4) line], 'LineWidth', 1.5);
                    plot(dt*(markers-1), (kinenergy(markers)-exactkinenergy)/exactkinenergy, [colors(4) marker_type(setnum)], 'LineWidth', 1.5);
                case {'2' 'bfOmega'}
                    ylabel('Angular velocity/body frame');                    
                    filename=[mfilename '-bfOmega-' num2str(dt)];
                    plot(dt*(0:npts-1), Omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Omegas(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Omegas(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\Omega_1', '\Omega_2', '\Omega_3');
                case {'3' 'omega'}
                    ylabel('Angular velocity/spatial frame'); 
                    filename=[mfilename '-omega-' num2str(dt)];
                    plot(dt*(0:npts-1), omegas(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), omegas(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), omegas(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), omegas(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\omega_1', '\omega_2', '\omega_3');
                case {'4' 'mom' 'pi'}
                    ylabel('Spatial angular momenta'); 
                    filename=[mfilename '-mom-' num2str(dt)];
                    plot(dt*(0:npts-1), momenta(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), momenta(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), momenta(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), momenta(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\pi_1', '\pi_2', '\pi_3');
                case {'5' 'vectup'}
                    ylabel('y-component of vector-up'); 
                    xlabel('x-component of vector-up'); 
                    filename=[mfilename '-vectup-' num2str(dt)];
                    hold on
                    axis square
                    plot(vectup(1,:), vectup(2,:), ['r'],  'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(vectup(1,markers), vectup(2,markers), ['b'  marker_type(setnum)],  'LineWidth', 1.5);
                case {'6' 'incrrotvec' 'incrvec'}
                    ylabel('Incremental rotation vector'); 
                    filename=[mfilename '-incrrotvec-' num2str(dt)];
                    plot(dt*(0:npts-1), incrrotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), incrrotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), incrrotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvect(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\Delta\Theta_1', '\Delta\Theta_2', '\Delta\Theta_3');
                case {'7' 'incrrotvecmag'}
                    ylabel('Magnitude of incremental rotation vector'); 
                    filename=[mfilename '-incrrotvecmag-' num2str(dt)];
                    plot(dt*(0:npts-1), incrrotvectmag(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), incrrotvectmag(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                case '8'
                    ylabel('Rotation vector'); 
                    filename=[mfilename '-rotvec-' num2str(dt)];
                    plot(dt*(0:npts-1), rotvect(1,:), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), rotvect(2,:), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), rotvect(3,:), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), rotvect(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\Theta_1', '\Theta_2', '\Theta_3');
                case '9'
                    view(3);
                    axis equal vis3d;
                    sphereplot(dt*(0:npts-1), vectup, 'init');
                    for i=1:npts
                        sphereplot([dt*(i-1)], vectup(:,i));
                    end
                    sphereplot([],[],'done');
                case '10'
                    ex_proj=proj_on_gravity(1,1);
                    ylabel('<\pi,g>'); 
                    filename=[mfilename '-projgrav-' num2str(dt)];
                    plot(dt*(0:npts-1), proj_on_gravity(1,:)-ex_proj, [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), proj_on_gravity(1,markers)-ex_proj, [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\pi*g');
                case '11'
                    ex_proj=proj_on_topaxis(1,1);
                    ylabel('\pi*\chi'); 
                    filename=[mfilename '-projtop-' num2str(dt)];
                    plot(dt*(0:npts-1), proj_on_topaxis(1,:)-ex_proj, [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), proj_on_topaxis(1,markers)-ex_proj, [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\pi*\chi');
                case {'13' 'hamilt'}
                    ylabel('Hamiltonian'); 
                    filename=[mfilename '-hamilt-' num2str(dt)];
                    plot(dt*(0:npts-1), (kinenergy+potenergy), [colors(setnum) '-'], 'LineWidth', 1.5); hold on
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), (kinenergy(markers)+potenergy(markers)), [colors(setnum) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('Hamiltonian');
                case {'normhamilt'}
                    ylabel('Hamiltonian'); 
                    filename=[mfilename '-hamilt-' num2str(dt)];
                    exh=kinenergy(1)+potenergy(1);
                    plot(dt*(0:npts-1), (kinenergy+potenergy)/exh, [colors(setnum) '-'], 'LineWidth', 1.5);
                    set(gca,'YLim', [0.95, 1.05])
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
%                     plot(dt*(markers-1), (kinenergy(markers)+potenergy(markers))/exh, [colors(setnum) marker_type(setnum)], 'LineWidth', 1.5);
%                     legend('Normalized Hamiltonian');
                case {'16' 'scaledhamilt'}
                    ylabel('(Error in Hamiltonian)/dt^2'); 
                    filename=[mfilename '-scaledhamilt-' num2str(dt)];
                    she=(kinenergy+potenergy-kinenergy(1)-potenergy(1))/dt^cr;
                    plot(dt*(0:npts-1), she, [colors(setnum) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), (kinenergy(markers)+potenergy(markers)-kinenergy(1)-potenergy(1))/dt^cr, [colors(setnum) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('(Error in Hamiltonian)/dt^2');
                case {'14' 'nmom'}
                    ylabel('Norm of spatial angular momenta'); 
                    filename=[mfilename '-nmom-' num2str(dt)];
                    nm=sqrt(momenta(1,:).*momenta(1,:)+momenta(2,:).*momenta(2,:)+momenta(3,:).*momenta(3,:));
                    plot(dt*(0:npts-1), nm, [colors(1) '-'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), nm(markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('||\pi||');
                case {'15' 'bfmomsphplt'}
                    view(3);
                    axis equal vis3d;
                    filename=[mfilename '-bfmomsphplt-' num2str(dt)];
                    sphereplot(dt*(0:npts-1), I*Omegas(:,1)/norm(exact_spm), 'init');
                    for i=1:npts
                        sphereplot([dt*(i-1)], I*Omegas(:,i)/norm(exact_spm));
                    end
                    sphereplot([],[],'done');
                    xlabel('\Pi_1');
                    ylabel('\Pi_2');
                    zlabel('\Pi_3');
                case {'Pi'}
                    ylabel('Angular momenta/body frame');                    
                    filename=[mfilename '-Pi-' num2str(dt)];
                    Pis=Omegas;
                    for i=1:npts
                        Pis(:,i)=I*Omegas(:,i);
                    end
                    plot(dt*(0:npts-1), Pis(1,1:npts), [colors(1) '-'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Pis(2,1:npts), [colors(2) ':'], 'LineWidth', 1.5);
                    plot(dt*(0:npts-1), Pis(3,1:npts), [colors(3) '-.'], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Pis(1,markers), [colors(1) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Pis(2,markers), [colors(2) marker_type(setnum)], 'LineWidth', 1.5);
                    nbtwmarkers=round(npts/nmarkers);
                    markers=nbtwmarkers*(1:round(npts/nbtwmarkers)-1);
                    nmarkers=nmarkers+2;
                    plot(dt*(markers-1), Pis(3,markers), [colors(3) marker_type(setnum)], 'LineWidth', 1.5);
                    legend('\Pi_1', '\Pi_2', '\Pi_3');
                case 'nothing'
                otherwise
                    error('Unknown plot type');
            end
           iplot=iplot+1;
        
            %pause(2.5);
            disp(['||R-converged R|| = ' num2str(norm(R-converged_R_at_200))]);
            nRs=[nRs norm(R-converged_R_at_200)];
            disp(['||Omega-converged Omega|| = ' num2str(norm(Omegas(:,end)-converged_Omega_at_200))]);
            nmbfs=[nmbfs norm(I*Omegas(:,end)-I*converged_Omega_at_200)];
            anRs.dts=dts;
            anRs.(class(ri))={nRs};
            anmbfs.dts=dts;
            anmbfs.(class(ri))={nmbfs};
            save([mfilename(1) 'anRs.mat'], 'anRs');
            save([mfilename(1) 'anmbfs.mat'], 'anmbfs');
        end
        for suffix={'fig' 'png' 'eps2'}
            suf=suffix{1};
            saveas(gcf, [filename '.' suf(1:3)], suf); 
        end
         %saveas(gcf, filename, 'png'); % eps2
        %         disp(['||R-converged R|| = ' num2str(norm(R-converged_R_at_100))]);
        %         nRs=[nRs norm(R-converged_R_at_100)];
        %         disp(['||Omega-converged Omega|| = ' num2str(norm(Omegas(:,end)-converged_Omega_at_100))]);
        %         nms=[nms norm(I*Omegas(:,end)-I*converged_Omega_at_100)];
    end
end
echo off