% H8 block mesh for a layered block (composite plate).
%
% function [fens,gcells] = H8_composite_plate(L,W,ts,nL,nW,nts)
%
% L,W= length and width,
% ts= Array of layer thicknesses,
% nL,nW= Number of elements per length and width,
% nts= array of numbers of elements per layer
%
% The gcells of each layer are labeled with the layer number.
%
function [fens,gcells] = H8_composite_plate(L,W,ts,nL,nW,nts)
tolerance =min(abs(ts))/max(nts)/10;
for layer =1:length(ts)
    if (layer==1)
        [fens,gcells] = H8_block(L,W,ts(layer),nL,nW,nts(layer));
        gcells=set(gcells,'label',layer);
    else
        [fens1,gcells1] = H8_block(L,W,ts(layer),nL,nW,nts(layer));
        gcells1=set(gcells1,'label',layer);
        [fens1] = translate_mesh(fens1, [0,0,sum(ts(1:layer-1))]);
        [fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tolerance);
        gcells=cat (gcells1,gcells2);
    end
end

