% Make H8 mesh of a solid  cylinder with a given number of element edges
% per radius.
% 
% function  [fens,gcells] = H8_cylinder_n(Radius, Length, nperradius, nL)
%     
function [fens,gcells] = H8_cylinder_n(Radius, Length, nperradius, nL)
    tol=min( [Length/nL,Radius/2/nperradius] )/100;
    [fens,gcells] = Q4_circle_n(Radius, nperradius, 1.0);
    fens2 = transform_apply(fens,@(x,d)([-x(2),x(1)]),  0);
    [fens,gcells,gcells2] = merge_meshes(fens, gcells, fens2, gcells, tol);
    gcells = cat(gcells,gcells2);
    fens2 = transform_apply(fens,@(x,d)([-x(1),-x(2)]),  0);
    [fens,gcells,gcells2] = merge_meshes(fens, gcells, fens2, gcells, tol);
    gcells = cat(gcells,gcells2);
    [fens,gcells] = Q4_extrude(fens,gcells,nL,@(x,k)([x(1),x(2),k*Length/nL]));
end