% Make H8 mesh of a solid  cylinder
% 
% function  [fens,gcells] = H8_half_cylinder(Radius, Length, nref, nL)
%     
function [fens,gcells] = H8_half_cylinder(Radius, Length, nref, nL)
    tol=min( [Length/nL,Radius/2/nref] )/100;
    [fens,gcells] = Q4_circle(Radius, nref, 1.0);
    fens2 = transform_apply(fens,@(x,d)([-x(2),x(1)]),  0);
    [fens,gcells,gcells2] = merge_meshes(fens, gcells, fens2, gcells, tol);
    gcells = cat(gcells,gcells2);
%     fens2 = transform_apply(fens,@(x,d)([-x(1),-x(2)]),  0);
%     [fens,gcells,gcells2] = merge_meshes(fens, gcells, fens2, gcells, tol);
%     gcells = cat(gcells,gcells2);
    [fens,gcells] = Q4_extrude(fens,gcells,nL,@(x,k)([x(1),x(2),k*Length/nL]));
end