% Create a mesh of a quarter circle.
%
% function [fens,gcells]=Q4_circle(radius,nrefine,thickness)
%
% Create a mesh of a quarter circle of "radius". The  mesh will consist of
% three quadrilateral elements if "nrefine==0", or more if "nrefine>0".
% "nrefine" is the number of bisections applied  to refine the mesh.
% The quadrilaterals have thickness "thickness".
function [fens,gcells]=Q4_circle(radius,nrefine,thickness)
    [fens,gcells]=Q4_sphere(radius,nrefine,thickness);
    % apply transformation to project the locations of the nodes into the
    % plane x-y
    xyz=get(fens,'xyz');
    for j=1:count(fens)
        xyz(j,1:2) = xyz(j,1:2)*((radius-norm(xyz(j,3)))+norm(xyz(j,3))/2)/radius;
    end
    fens=set(fens,'xyz', xyz(:,1:2));
end
