% Convert a mesh of Tetrahedron T10 to Tetrahedron T4 (four-node).
%
% function [fens,gcells] = T10_to_T4(fens,gcells)
%
function [fens,gcells] = T10_to_T4(fens,gcells)
    conn =get(gcells,'conn') ;
    gcells=gcellset_T4(struct('conn',conn(:,1:4)));
    connected = find_unconn_fens(fens, gcells);
    [fens, new_numbering] =compact_fens(fens, connected);
    gcells = renumber_gcell_conn(gcells, new_numbering);
end
