% Construct a sparse matrix from connectivities.
% 
% function A = conn_to_sparse(conns)
%     
% conns = cell array of connectivity arrays, A = sparse matrix
function A = conn_to_sparse(conns)
    n=0; % dimension of the matrix
    for C=1:length(conns)
        conn=conns{C};
        n=max([max(max(conn)) n]);
    end
    nconn =cell(1,n);
    for C=1:length(conns)
        conn=conns{C};
        for j=1:length(conn)
%               nconn{conn(j)}= unique([nconn{conn(j)} conn]);%Old way
            nconn{conn(j)}= ([nconn{conn(j)} conn]);% New way
        end
    end
    ns=0;
    for j=1:length(nconn)
        %         nconn{j}= unique(nconn{j});% New way
        ns =ns +length(nconn{j});
    end
%     ns
    sppatti=zeros(1,ns);
    sppattj=zeros(1,ns);
    si=1;
    for j=1:length(nconn)
        nn =length(nconn{j});
        sppatti(si:si+nn-1)=j;
        sppattj(si:si+nn-1)=nconn{j};
        si=si+nn;
    end
    clear nconn;
    A=sparse(sppatti, sppattj, 1.0, double(n), double(n));
    %         nnz(A)
    %     %  spy(A)
end

% Make a sparse matrix out of connectivities.
% conns = cell array of connectivity arrays
% function A = conn_to_sparse(conns)
%     n=0; % dimension of the matrix
%     ns=0; % size of the sparsity pattern arrays
%     for C=1:length(conns)
%         conn=conns{C};
%         n=max([max(max(conn)) n]);
%         nn=size(conn,2);
%         ne=size(conn,1);
%         ns=ns+(ne*nn^2);
%     end
%     ns
%     sppatti=zeros(1,ns);
%     sppattj=zeros(1,ns);
%     si=1;
%     for C=1:length(conns)
%         conn=conns{C};
%         ne=size(conn,1);
%         nn=size(conn,2);
%         for i=1:ne
%             %if (round(i/1000)*1000 == i) disp(['Elem ' num2str(i)]); end
%             for j=1:nn
%                 sppatti(si:si+nn-1)=conn(i,:);
%                 sppattj(si:si+nn-1)=conn(i,j);
%                 si=si+nn;
%             end
%         end
%     end
%     A=sparse(sppatti, sppattj, 1.0, n, n);
%     nnz(A)
%     spy(A)
% end