% Renumber the finite element nodes and the geometric cells using the
% numbering supplied.  The numbering may be computed with
% renum_mesh_numbering().
% 
% function [fens, varargout]=mesh_renumber(numbering, fens, varargin)
%  
% numbering = compute with  renum_mesh_numbering()
% fens = arrays of finite element nodes and geometric cells
% varargin = any number of gcellset Variables
% 
function [fens, varargout]=mesh_renumber(numbering, fens, varargin)
    id =get(fens,'id');
    xyz =get(fens,'xyz');
    if (length(id)~=length(numbering.p))
        error('Length mismatch');
    end
    if (length(id)~= size(xyz,1))
        error('Length mismatch');
    end
    %     fens =set(fens,'id',id);
    fens =set(fens,'xyz',xyz(numbering.p,:));

    for k= 1 : size(varargin,2)
        gcells = varargin{k};
        conn=get(gcells,'conn');
        for i=1:size(conn,1)
            conn(i,:) =numbering.ip(conn(i,:));
        end
        varargout{k}=set(gcells,'conn',conn);
    end

end
% fens(C)=set(ofens(numbering.p(C)),'id',C);

