function  avw= to_avw (fens,gcells,integration_rule)
conns = get(gcells, 'conn'); % connectivity
pc = get(integration_rule, 'param_coords');
    w  = get(integration_rule, 'weights');
    npts_per_gcell = get(integration_rule, 'npts');
    % Figure out the extent of the geometry
geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
limits =reshape([min(get(geom,'values'));max(get(geom,'values'))], 6, 1);
xs =gather(geom,(1:get(geom,'nfens')),'values','noreshape');
% Find the minimum circumscribed diameter to use as an indicator of the size of the voxels
    smallest_circumscribed_diameter =inf;
    for i=1:size(conns,1)
        conn =conns(i,:);
        x=xs(conn,:);
        smallest_circumscribed_diameter =min([smallest_circumscribed_diameter,max(x(:,1))-min(x(:,1))]);
        smallest_circumscribed_diameter =min([smallest_circumscribed_diameter,max(x(:,2))-min(x(:,2))]);
        smallest_circumscribed_diameter =min([smallest_circumscribed_diameter,max(x(:,3))-min(x(:,3))]);
    end
   % Shift the geometry towards the origin
xs = [xs(:,1)-limits(1),xs(:,2)-limits(3),xs(:,3)-limits(5)]+smallest_circumscribed_diameter;
geom = field(struct ('name',['geom'], 'dim', 3, 'data',xs));
 xs =gather(geom,(1:get(geom,'nfens')),'values','noreshape');
limits =reshape([min(get(geom,'values'));max(get(geom,'values'))], 6, 1);
    % Determine the image dimensions
    pixdim = [1,1,1]*smallest_circumscribed_diameter;
    dim =round((limits([2,4,6])'+smallest_circumscribed_diameter)./pixdim)+1;
    options=struct('pixdim', pixdim,...
    'dim',dim,...
    'name', 'image',...
    'fill_pixel', 0);
% 
avw=avw_blank(options);
    for j=1:npts_per_gcell
        Ns{j} = bfun(gcells,pc(j,:));
    end
    for i=1:size(conns,1)
        conn =conns(i,:);
        x=xs(conn,:);
        for j=1:npts_per_gcell
            c =transpose (Ns{j})*x;% physical location of the quadrature point
            % Voxel coordinates
            vi = round(c./pixdim);
            avw.img(vi(1),vi(2),vi(3))=1;
        end
    end
    
end
